import { z } from "zod";
import { Config } from "../../types/config";
import { server } from "./server.config";

const envSchema = z.object({
  NODE_ENV: z.enum(["development", "production", "test"]),
});

const { error, data: envVars } = envSchema.safeParse(process.env);

if (error) {
  throw new Error(`Config validation error: ${error.message}`);
}

export const general: Config = {
  env: envVars.NODE_ENV,
  isDevelopment: envVars.NODE_ENV === "development",
  server,
};
